#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <libndls.h>
#include <string>
#include <memory>

#include "malloc-wrapper.h"

using namespace std;



int main(void)
{
	/*
	unique_ptr<string> p = make_unique<string>("test string");
	void* t = malloc(10);
	free(t);
	malloc(10); // intentional memory leak
	string *s = new string("test2");
	*/
	
	volatile uint32_t *rtc_val = (volatile uint32_t*) 0x90090000;
	volatile uint32_t *timer = (volatile uint32_t*) 0x900C0000;
	volatile unsigned int *peripherals = (volatile unsigned int*) 0x900B0018; // https://hackspire.org/index.php?title=Memory-mapped_I/O_ports_on_CX#900B0000_-_Power_management
	volatile unsigned int *peripherals2 = (volatile unsigned int*) 0x900B0020;
	
	*peripherals = 0;
	*peripherals2 = 0;
	
	bool enabled = false;
	if (((timer[3] >> 7) & 0b1) == 1)
	{
		enabled = true;
	}
	timer[3] = 0;
	timer[3] = 0b01000010;
	timer[3] |= 0b1 << 7;
	timer[2] = 0xffffffff;
	timer[32] = 0xa;
	
	volatile uint32_t rtc_time = *rtc_val;
	volatile uint32_t ticks = timer[1];
	volatile void* temp[1000];
	for (volatile uint32_t i = 0;i<1000;i++) // so this doesn't get optimized out
	{
		temp[i] = malloc(10); // fill the wrapper list before
	}
	for (volatile uint32_t i = 0;i<100000;i++) // so this doesn't get optimized out
	{
		volatile void* p = malloc(10); // so this doesn't get optimized out
		free(const_cast<void*>(p));
	}
	for (volatile uint32_t i = 0;i<1000;i++) // so this doesn't get optimized out
	{
		if (temp[i] != NULL)
		{
			free(const_cast<void*>(temp[i]));
		}
	}
	volatile uint32_t delta = ticks-timer[1];
	volatile uint32_t rtc_delta = *rtc_val - rtc_time;
	if (! enabled)
	{
		timer[3] &= ~(0b1 << 7);
	}
	
	char buffer[300];
	memset(buffer,'\0',300);
	
	sprintf(buffer,"ticks: %lu, seconds: %lu",delta,rtc_delta);
	
	show_msgbox("timertest",buffer);
	
	
	
	//deallocate_exit(0);
}










